<%
	if defined?(componentIndex) # Then we're working with a component
	  prefix = "component_#{componentIndex}_"
	  htmlOpen = "<tr><td>%s</td><td><ul class='styled'>"
	  htmlClose = "</ul></td></tr>"
	else # We're working with an object or collection
	  prefix = ''
	  htmlOpen = "<dt>%s</dt><dd><ul class='unstyled'>"
	  htmlClose = "</ul></dd>"
	end

	types = Hash.new
	types.compare_by_identity
	needLabel = "false"
    linkNumber = 20

	fieldData = collectionDoc["#{prefix}related_resource_json_tesim"]

	if fieldData != nil
	  fieldData.each do |datum|
	    relatedResource = JSON.parse(datum)
	    if has_values(relatedResource) && relatedResource['type'] != "hydra-afmodel"
	      needLabel = "true"
	    end
	  end

	  fieldData.each do |datum|
	    relatedResource = JSON.parse(datum)
	    if has_values(relatedResource) && relatedResource['type'] != "hydra-afmodel"
	      if relatedResource['type'] != 'thumbnail'
	        # add link information as value to hashmap
	        types[relatedResource['type']] = relatedResource
	      end
	    end
	  end
	else
	  needLabel = "true"
	end

	if !@collectionDocArray.nil? && @collectionDocArray.size > 0
	  @collectionDocArray.each do |colDoc|
	    fieldData = colDoc["#{prefix}related_resource_json_tesim"]
	    if fieldData != nil
	      fieldData.each do |datum|
	        relatedResource = JSON.parse(datum)
	        if has_values(relatedResource) && relatedResource['type'] != "hydra-afmodel" && (relatedResource['type'].include?("online") || relatedResource['type'] == "news release")
	          if relatedResource['type'] != 'thumbnail'
	            # add related resource as value to hashmap
	            types[relatedResource['type']] = relatedResource
	            needLabel = "true"
	          end
	        end
	      end
	    end
	  end
	end
	types = types.group_by {|word| word[0]}
	count = 0
	types.each do |c|
	  count += 1
	end

	if needLabel == "true" && count > 0
	  htmlOpen %= 'Related Resource'.pluralize(count)
	  concat htmlOpen.html_safe
	end
	types.each do |key, value|
	  resWithLabel = value.select {|v| !v[1]['displayLabel'].blank?}.first
	  displayLabel = !resWithLabel.nil? ? resWithLabel[1]['displayLabel'] : !key.blank? ? key : 'General Related Resource'

	  if !defined?(componentIndex) # For object and collection
	%>
	  <p>
	    <strong>
	      <%= displayLabel.capitalize %>
	    </strong>
	  </p>
	  <ul>
	<%
	  end

	  link_count = 0
	  value.each do |k, v| 
	    url = v['uri']
	    description = v['description']
	    prefix = v['prefix']
	    link_count += 1
	    related_resource_class = ""
	    if(link_count > linkNumber )
	      related_resource_class = ' class=related_resources_link'
	    end

        if defined?(componentIndex) # Working with components
      %>
        <li>
          <span class="rrc_label"><%= displayLabel.capitalize %>: </span>
      <%
        else # List for object and collection
      %>
        <li<%= related_resource_class%>>
      <%
        end

        if !prefix.blank?
      %>
          <span class="rr_prefix"><%= prefix %> </span>
      <%
        end
        if(!@relResourceHash.nil? && @relResourceHash.has_key?(url))
      %>
          <%= link_to description, dams_object_path("#{url.sub( Rails.configuration.id_namespace, '' )}") %>
      <%
        elsif url.blank?
      %>
          <%= description %>
      <%
        elsif description.blank?
      %>
          <%= link_to url, url %>
      <%
         else
      %>
          <%= link_to description, url %>
      <%
        end

        if defined?(componentIndex) && link_count != value.length # For a component we need line separator
      %>
        <br/>
      <%
        else
      %>
        </li>
        </p>
      <%
        end

        if(!defined?(componentIndex) && link_count == linkNumber && value.size > linkNumber)
      %>
          <a href="#more_related_resources" id="more_related_resources">More ...</a>
      <%
        end
	  end

	  if defined?(componentIndex) # Close list for a component
	  %>
	  </li>
	  <%
	  else
	  %>
	  </ul>
	  <%
	  end
	end

	if(needLabel == "true")
	  concat htmlClose.html_safe
	end

%>
